import logging
from typing import Callable,Optional
from moto.s3.models import FakeBucket
from moto.sqs.models import Queue
from localstack_ext.bootstrap.pods.service_state import Backends
from localstack_ext.bootstrap.state_merge import merge_kinesis_state,merge_object_state
from localstack_ext.bootstrap.state_merge_ddb import merge_dynamodb
from localstack_ext.utils.persistence import marshal_backend
LOG=logging.getLogger(__name__)
def merge_backends(service,a,b,ancestor=None):
	D=ancestor;B=service;from localstack_ext.utils.persistence import unmarshal_backend as C
	for A in b:
		if A in a:
			LOG.debug('Merging two states for %s',B)
			if is_special_case(b[A]):continue
			E=C(b[A]);F=C(a[A]);G=None if not D else C(D[A])
			try:H=merge_object_state(current=F,injecting=E,common_ancestor=G);a[A]=marshal_backend(H)
			except Exception as I:LOG.debug('Failed to merge backends for service %s: %s',B,I)
		else:LOG.debug('No merge needed for service %s: copying B state in A',B);a[A]=b[A]
def get_merge_function_for_assets(service):
	match service:
		case'dynamodb':return merge_dynamodb
		case'kinesis':return merge_kinesis_state
		case _:return
def is_special_case(obj):return isinstance(obj,(Queue,FakeBucket))